From f3f760a59b19bcdf48e2e7a4aea73cead7c92add Mon Sep 17 00:00:00 2001
From: Jiangyi Chen <chenjiangyi@uniontech.com>
Date: Sun, 13 Dec 2020 15:37:40 +0800
Subject: [PATCH] kernelbase: Setting FileEndOfFileInfo has been implemented in
 NtSetInformationFile. SetFileInformationByHandle should do the same call as
 SetEndOfFile in case of FileEndOfFileInfo. Some tests have been done, and the
 results show that this modification can work well.

Signed-off-by: Jiangyi Chen <chenjiangyi@uniontech.com>
---
 dlls/kernelbase/file.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/dlls/kernelbase/file.c b/dlls/kernelbase/file.c
index 7b122e263b0..c7aa1ef1440 100644
--- a/dlls/kernelbase/file.c
+++ b/dlls/kernelbase/file.c
@@ -3528,7 +3528,6 @@ BOOL WINAPI DECLSPEC_HOTPATCH SetFileInformationByHandle( HANDLE file, FILE_INFO
     case FileNameInfo:
     case FileRenameInfo:
     case FileAllocationInfo:
-    case FileEndOfFileInfo:
     case FileStreamInfo:
     case FileIdBothDirectoryInfo:
     case FileIdBothDirectoryRestartInfo:
@@ -3549,6 +3548,9 @@ BOOL WINAPI DECLSPEC_HOTPATCH SetFileInformationByHandle( HANDLE file, FILE_INFO
     case FileDispositionInfo:
         status = NtSetInformationFile( file, &io, info, size, FileDispositionInformation );
         break;
+    case FileEndOfFileInfo:
+        status = NtSetInformationFile( file, &io, info, size, FileEndOfFileInformation );
+        break;
     case FileIoPriorityHintInfo:
         status = NtSetInformationFile( file, &io, info, size, FileIoPriorityHintInformation );
         break;
-- 
2.20.1

